searchData={"content_type":"text/markdown","items":[{"doc":"","ref":"ExIndexea.html","title":"ExIndexea","type":"module"},{"doc":"Take an existing URI and add addition params, appending and replacing as necessary.","ref":"ExIndexea.html#add_params_to_url/2","title":"ExIndexea.add_params_to_url/2","type":"function"},{"doc":"iex> add_params_to_url(\"http://example.com/wat\", [])\n    \"http://example.com/wat\"\n\n    iex> add_params_to_url(\"http://example.com/wat\", [q: 1])\n    \"http://example.com/wat?q=1\"\n\n    iex> add_params_to_url(\"http://example.com/wat\", [q: 1, t: 2])\n    \"http://example.com/wat?q=1&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat\", %{q: 1, t: 2})\n    \"http://example.com/wat?q=1&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1&t=2\", [])\n    \"http://example.com/wat?q=1&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1\", [t: 2])\n    \"http://example.com/wat?q=1&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1\", [q: 3, t: 2])\n    \"http://example.com/wat?q=3&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1&s=4\", [q: 3, t: 2])\n    \"http://example.com/wat?q=3&s=4&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1&s=4\", %{q: 3, t: 2})\n    \"http://example.com/wat?q=3&s=4&t=2\"","ref":"ExIndexea.html#add_params_to_url/2-examples","title":"Examples - ExIndexea.add_params_to_url/2","type":"function"},{"doc":"Same as `authorization_header/2` but defaults initial headers to include `@user_agent`.","ref":"ExIndexea.html#authorization_header/1","title":"ExIndexea.authorization_header/1","type":"function"},{"doc":"","ref":"ExIndexea.html#authorization_header/2","title":"ExIndexea.authorization_header/2","type":"function"},{"doc":"Issues a DELETE request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"ExIndexea.html#delete/3","title":"ExIndexea.delete/3","type":"function"},{"doc":"","ref":"ExIndexea.html#delete/4","title":"ExIndexea.delete/4","type":"function"},{"doc":"Issues a DELETE request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"ExIndexea.html#delete!/3","title":"ExIndexea.delete!/3","type":"function"},{"doc":"Issues a GET request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"ExIndexea.html#get/3","title":"ExIndexea.get/3","type":"function"},{"doc":"Underlying utility retrieval function. The options passed affect both the\nreturn value and, ultimately, the number of requests made to GitHub.","ref":"ExIndexea.html#get/4","title":"ExIndexea.get/4","type":"function"},{"doc":"* `:pagination` - Can be `:none`, `:manual`, `:stream`, or `:auto`. Defaults to :auto.\n\n      - `:none` will only return the first page. You won't have access to the\n        headers to manually paginate.\n\n      - `:auto` will block until all the pages have been retrieved and\n        concatenated together. Most of the time, this is what you want. For\n        example, `Tentacat.Repositories.list_users(\"chrismccord\")` and\n        `Tentacat.Repositories.list_users(\"octocat\")` have the same interface\n        though one call will page many times and the other not at all.\n\n      - `:stream` will return a `Stream`, prepopulated with the first page.\n\n      - `:manual` will return a 3 element tuple of `{page_body,\n        url_for_next_page, auth_credentials}`, which will allow you to control\n        the paging yourself.","ref":"ExIndexea.html#get/4-options","title":"Options - ExIndexea.get/4","type":"function"},{"doc":"Issues a GET request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"ExIndexea.html#get!/3","title":"ExIndexea.get!/3","type":"function"},{"doc":"Issues a HEAD request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"ExIndexea.html#head/3","title":"ExIndexea.head/3","type":"function"},{"doc":"Issues a HEAD request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"ExIndexea.html#head!/3","title":"ExIndexea.head!/3","type":"function"},{"doc":"","ref":"ExIndexea.html#json_request/6","title":"ExIndexea.json_request/6","type":"function"},{"doc":"Issues an OPTIONS request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"ExIndexea.html#options/3","title":"ExIndexea.options/3","type":"function"},{"doc":"Issues a OPTIONS request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"ExIndexea.html#options!/3","title":"ExIndexea.options!/3","type":"function"},{"doc":"Issues a PATCH request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"ExIndexea.html#patch/4","title":"ExIndexea.patch/4","type":"function"},{"doc":"Issues a PATCH request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"ExIndexea.html#patch!/4","title":"ExIndexea.patch!/4","type":"function"},{"doc":"Issues a POST request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"ExIndexea.html#post/4","title":"ExIndexea.post/4","type":"function"},{"doc":"Issues a POST request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"ExIndexea.html#post!/4","title":"ExIndexea.post!/4","type":"function"},{"doc":"","ref":"ExIndexea.html#process_headers/1","title":"ExIndexea.process_headers/1","type":"function"},{"doc":"","ref":"ExIndexea.html#process_request_body/1","title":"ExIndexea.process_request_body/1","type":"function"},{"doc":"","ref":"ExIndexea.html#process_request_headers/1","title":"ExIndexea.process_request_headers/1","type":"function"},{"doc":"","ref":"ExIndexea.html#process_request_options/1","title":"ExIndexea.process_request_options/1","type":"function"},{"doc":"","ref":"ExIndexea.html#process_request_params/1","title":"ExIndexea.process_request_params/1","type":"function"},{"doc":"","ref":"ExIndexea.html#process_request_url/1","title":"ExIndexea.process_request_url/1","type":"function"},{"doc":"","ref":"ExIndexea.html#process_response/1","title":"ExIndexea.process_response/1","type":"function"},{"doc":"","ref":"ExIndexea.html#process_response_body/1","title":"ExIndexea.process_response_body/1","type":"function"},{"doc":"","ref":"ExIndexea.html#process_response_chunk/1","title":"ExIndexea.process_response_chunk/1","type":"function"},{"doc":"","ref":"ExIndexea.html#process_response_headers/1","title":"ExIndexea.process_response_headers/1","type":"function"},{"doc":"","ref":"ExIndexea.html#process_response_status_code/1","title":"ExIndexea.process_response_status_code/1","type":"function"},{"doc":"","ref":"ExIndexea.html#process_status_code/1","title":"ExIndexea.process_status_code/1","type":"function"},{"doc":"","ref":"ExIndexea.html#process_url/1","title":"ExIndexea.process_url/1","type":"function"},{"doc":"Issues a PUT request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"ExIndexea.html#put/4","title":"ExIndexea.put/4","type":"function"},{"doc":"Issues a PUT request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"ExIndexea.html#put!/4","title":"ExIndexea.put!/4","type":"function"},{"doc":"","ref":"ExIndexea.html#raw_request/6","title":"ExIndexea.raw_request/6","type":"function"},{"doc":"Issues an HTTP request using an `HTTPoison.Request` struct.\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"ExIndexea.html#request/1","title":"ExIndexea.request/1","type":"function"},{"doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"ExIndexea.html#request/1-redirect-handling","title":"Redirect handling - ExIndexea.request/1","type":"function"},{"doc":"request = %HTTPoison.Request{\n      method: :post,\n      url: \"https://my.website.com\",\n      body: \"{\\\"foo\\\": 3}\",\n      headers: [{\"Accept\", \"application/json\"}]\n    }\n\n    request(request)","ref":"ExIndexea.html#request/1-examples","title":"Examples - ExIndexea.request/1","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url.\n\nThis function is usually used indirectly by `get/3`, `post/4`, `put/4`, etc\n\nArgs:\n  * `method` - HTTP method as an atom (`:get`, `:head`, `:post`, `:put`,\n    `:delete`, etc.)\n  * `url` - target url as a binary string or char list\n  * `body` - request body. See more below\n  * `headers` - HTTP headers as an orddict (e.g., `[{\"Accept\", \"application/json\"}]`)\n  * `options` - Keyword list of options\n\nBody: see type `HTTPoison.Request`\n\nOptions: see type `HTTPoison.Request`\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"ExIndexea.html#request/5","title":"ExIndexea.request/5","type":"function"},{"doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"ExIndexea.html#request/5-redirect-handling","title":"Redirect handling - ExIndexea.request/5","type":"function"},{"doc":"request(:post, \"https://my.website.com\", \"{\\\"foo\\\": 3}\", [{\"Accept\", \"application/json\"}])","ref":"ExIndexea.html#request/5-examples","title":"Examples - ExIndexea.request/5","type":"function"},{"doc":"Issues an HTTP request an `HTTPoison.Request` struct.\nexception in case of failure.\n\n`request!/1` works exactly like `request/1` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"ExIndexea.html#request!/1","title":"ExIndexea.request!/1","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url, raising an\nexception in case of failure.\n\n`request!/5` works exactly like `request/5` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"ExIndexea.html#request!/5","title":"ExIndexea.request!/5","type":"function"},{"doc":"","ref":"ExIndexea.html#request_stream/5","title":"ExIndexea.request_stream/5","type":"function"},{"doc":"","ref":"ExIndexea.html#request_with_pagination/4","title":"ExIndexea.request_with_pagination/4","type":"function"},{"doc":"Starts HTTPoison and its dependencies.","ref":"ExIndexea.html#start/0","title":"ExIndexea.start/0","type":"function"},{"doc":"Requests the next message to be streamed for a given `HTTPoison.AsyncResponse`.\n\nSee `request!/5` for more detailed information.","ref":"ExIndexea.html#stream_next/1","title":"ExIndexea.stream_next/1","type":"function"},{"doc":"","ref":"ExIndexea.html#t:body/0","title":"ExIndexea.body/0","type":"type"},{"doc":"","ref":"ExIndexea.html#t:headers/0","title":"ExIndexea.headers/0","type":"type"},{"doc":"","ref":"ExIndexea.html#t:method/0","title":"ExIndexea.method/0","type":"type"},{"doc":"","ref":"ExIndexea.html#t:options/0","title":"ExIndexea.options/0","type":"type"},{"doc":"","ref":"ExIndexea.html#t:pagination_response/0","title":"ExIndexea.pagination_response/0","type":"type"},{"doc":"","ref":"ExIndexea.html#t:params/0","title":"ExIndexea.params/0","type":"type"},{"doc":"","ref":"ExIndexea.html#t:request/0","title":"ExIndexea.request/0","type":"type"},{"doc":"","ref":"ExIndexea.html#t:response/0","title":"ExIndexea.response/0","type":"type"},{"doc":"","ref":"ExIndexea.html#t:url/0","title":"ExIndexea.url/0","type":"type"},{"doc":"","ref":"ExIndexea.Client.html","title":"ExIndexea.Client","type":"module"},{"doc":"","ref":"ExIndexea.Client.html#new/0","title":"ExIndexea.Client.new/0","type":"function"},{"doc":"","ref":"ExIndexea.Client.html#new/1","title":"ExIndexea.Client.new/1","type":"function"},{"doc":"","ref":"ExIndexea.Client.html#new/2","title":"ExIndexea.Client.new/2","type":"function"},{"doc":"","ref":"ExIndexea.Client.html#t:auth/0","title":"ExIndexea.Client.auth/0","type":"type"},{"doc":"","ref":"ExIndexea.Client.html#t:t/0","title":"ExIndexea.Client.t/0","type":"type"},{"doc":"","ref":"ExIndexea.Config.html","title":"ExIndexea.Config","type":"module"},{"doc":"","ref":"ExIndexea.Config.html#access_token/0","title":"ExIndexea.Config.access_token/0","type":"function"},{"doc":"","ref":"ExIndexea.Config.html#app/0","title":"ExIndexea.Config.app/0","type":"function"},{"doc":"","ref":"ExIndexea.Config.html#version/0","title":"ExIndexea.Config.version/0","type":"function"},{"doc":"","ref":"ExIndexea.Queries.html","title":"ExIndexea.Queries","type":"module"},{"doc":"","ref":"ExIndexea.Queries.html#search_query/5","title":"ExIndexea.Queries.search_query/5","type":"function"},{"doc":"","ref":"ExIndexea.Records.html","title":"ExIndexea.Records","type":"module"},{"doc":"","ref":"ExIndexea.Records.html#delete_by_query/6","title":"ExIndexea.Records.delete_by_query/6","type":"function"},{"doc":"","ref":"ExIndexea.Records.html#list/5","title":"ExIndexea.Records.list/5","type":"function"},{"doc":"","ref":"ExIndexea.Records.html#push/5","title":"ExIndexea.Records.push/5","type":"function"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}